Imports I87KCANnet_PAC
Imports DCONCE
Imports Wincon

Public Class Form1

    Dim Slot As Integer
    Dim Ret As Integer
    Dim Baud As UInteger
    Dim ComPort As Byte
    Dim Scroll As Byte
    Dim MsgCnt As ULong


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ComPort = 0
        Scroll = 1

        pan_rx.Enabled = False
        pan_tx.Enabled = False
        bt_close.Enabled = False

        cb_baud.SelectedIndex = 0
        cb_slot.SelectedIndex = 0

        tx1_mode.Text = "0"
        tx1_id.Text = "123"
        tx1_rtr.Text = "0"
        tx1_dlen.Text = "8"
        tx1_d0.Text = "11"
        tx1_d1.Text = "22"
        tx1_d2.Text = "33"
        tx1_d3.Text = "44"
        tx1_d4.Text = "55"
        tx1_d5.Text = "66"
        tx1_d6.Text = "77"
        tx1_d7.Text = "88"

        tx2_mode.Text = "0"
        tx2_id.Text = "123"
        tx2_rtr.Text = "0"
        tx2_dlen.Text = "8"
        tx2_d0.Text = "11"
        tx2_d1.Text = "22"
        tx2_d2.Text = "33"
        tx2_d3.Text = "44"
        tx2_d4.Text = "55"
        tx2_d5.Text = "66"
        tx2_d6.Text = "77"
        tx2_d7.Text = "88"
    End Sub
    Private Sub bt_close_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_close.Click
        Ret = I87KCANnet_PAC.I87KCAN.ResetI87KCAN()
        If (Ret <> 0) Then
            MessageBox.Show("I-87120 Reset Err = " + Str(Ret))
        Else
            MsgCnt = 0
            Scroll = 1

            cb_baud.Enabled = True
            cb_slot.Enabled = True
            bt_config.Enabled = True

            pan_rx.Enabled = False
            pan_tx.Enabled = False
            bt_close.Enabled = False
            timer1.Enabled = False

            bt_scroll.Text = "Stop Scroll"
            bt_receive.Text = "Receive"

            DCONCE.Dcon.UART.Close_Com(ComPort)
        End If
    End Sub
    Private Sub bt_config_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_config.Click
        Dim buf(100) As Byte
        Slot = cb_slot.SelectedIndex
        Select Case (cb_baud.SelectedIndex)
            Case 0
                Baud = 10000
            Case 1
                Baud = 20000
            Case 2
                Baud = 50000
            Case 3
                Baud = 125000
            Case 4
                Baud = 250000
            Case 5
                Baud = 500000
            Case 6
                Baud = 800000
            Case 7
                Baud = 1000000
        End Select

        DCONCE.Dcon.UART.Open_Com(ComPort, 115200, 8, 0, 0)
        Wincon.Wcon.System.ChangeSlotTo87K(Slot)

        Ret = I87KCANnet_PAC.I87KCAN.I87KCANInit(Baud, 0, 0, 0, &HFFFFFFFF, 1, 0)
        If (Ret <> 0) Then
            MessageBox.Show("I-87120 Initial Err = " + Str(Ret))
            DCONCE.Dcon.UART.Close_Com(ComPort)
        Else
            cb_baud.Enabled = False
            cb_slot.Enabled = False
            bt_config.Enabled = False

            pan_rx.Enabled = True
            pan_tx.Enabled = True
            bt_close.Enabled = True
        End If
    End Sub
    Private Sub timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles timer1.Tick
        Dim Mode As Byte
        Dim Rtr As Byte
        Dim Dlen As Byte
        Dim Data(8) As Byte
        Dim ID As UInteger
        Dim CANStr As String

        Ret = I87KCANnet_PAC.I87KCAN.GetCANMsg(Mode, ID, Rtr, Dlen, Data(0))
        If ((Ret <> 0) And (Ret <> 21) And (Ret <> 22)) Then
            CANStr = "I-87120 Receive Err = " + Str(Ret)
            list_receive.Items.Add(CANStr)
        ElseIf (Ret = 0) Then
            If (MsgCnt = 10000) Then
                list_receive.Items.Clear()
                MsgCnt = 0
            End If

            Select Case (Dlen)
                Case 0
                    CANStr = Format(MsgCnt, "0000") + " Mode:" + Str(Mode) + " , ID:" + Hex(ID) + " , Rtr:" + Str(Rtr) + " , Dlen:" + Str(Dlen) + " , Data: ..."
                Case 1
                    CANStr = Format(MsgCnt, "0000") + " Mode:" + Str(Mode) + " , ID:" + Hex(ID) + " , Rtr:" + Str(Rtr) + " , Dlen:" + Str(Dlen) + " , Data: " + _
                    Format(Hex(Data(0)), "00")
                Case 2
                    CANStr = Format(MsgCnt, "0000") + " Mode:" + Str(Mode) + " , ID:" + Hex(ID) + " , Rtr:" + Str(Rtr) + " , Dlen:" + Str(Dlen) + " , Data: " + _
                    Format(Hex(Data(0)), "00") + "," + Format(Hex(Data(1)), "00")
                Case 3
                    CANStr = Format(MsgCnt, "0000") + " Mode:" + Str(Mode) + " , ID:" + Hex(ID) + " , Rtr:" + Str(Rtr) + " , Dlen:" + Str(Dlen) + " , Data: " + _
                    Format(Hex(Data(0)), "00") + "," + Format(Hex(Data(1)), "00") + "," + Format(Hex(Data(2)), "00")
                Case 4
                    CANStr = Format(MsgCnt, "0000") + " Mode:" + Str(Mode) + " , ID:" + Hex(ID) + " , Rtr:" + Str(Rtr) + " , Dlen:" + Str(Dlen) + " , Data: " + _
                    Format(Hex(Data(0)), "00") + "," + Format(Hex(Data(1)), "00") + "," + Format(Hex(Data(2)), "00") + "," + Format(Hex(Data(3)), "00")
                Case 5
                    CANStr = Format(MsgCnt, "0000") + " Mode:" + Str(Mode) + " , ID:" + Hex(ID) + " , Rtr:" + Str(Rtr) + " , Dlen:" + Str(Dlen) + " , Data: " + _
                    Format(Hex(Data(0)), "00") + "," + Format(Hex(Data(1)), "00") + "," + Format(Hex(Data(2)), "00") + "," + Format(Hex(Data(3)), "00") + _
                    "," + Format(Hex(Data(4)), "00")
                Case 6
                    CANStr = Format(MsgCnt, "0000") + " Mode:" + Str(Mode) + " , ID:" + Hex(ID) + " , Rtr:" + Str(Rtr) + " , Dlen:" + Str(Dlen) + " , Data: " + _
                    Format(Hex(Data(0)), "00") + "," + Format(Hex(Data(1)), "00") + "," + Format(Hex(Data(2)), "00") + "," + Format(Hex(Data(3)), "00") + _
                    "," + Format(Hex(Data(4)), "00") + "," + Format(Hex(Data(5)), "00")
                Case 7
                    CANStr = Format(MsgCnt, "0000") + " Mode:" + Str(Mode) + " , ID:" + Hex(ID) + " , Rtr:" + Str(Rtr) + " , Dlen:" + Str(Dlen) + " , Data: " + _
                    Format(Hex(Data(0)), "00") + "," + Format(Hex(Data(1)), "00") + "," + Format(Hex(Data(2)), "00") + "," + Format(Hex(Data(3)), "00") + _
                    "," + Format(Hex(Data(4)), "00") + "," + Format(Hex(Data(5)), "00") + "," + Format(Hex(Data(6)), "00")
                Case 8
                    CANStr = Format(MsgCnt, "0000") + " Mode:" + Str(Mode) + " , ID:" + Hex(ID) + " , Rtr:" + Str(Rtr) + " , Dlen:" + Str(Dlen) + " , Data: " + _
                    Format(Hex(Data(0)), "00") + "," + Format(Hex(Data(1)), "00") + "," + Format(Hex(Data(2)), "00") + "," + Format(Hex(Data(3)), "00") + _
                    "," + Format(Hex(Data(4)), "00") + "," + Format(Hex(Data(5)), "00") + "," + Format(Hex(Data(6)), "00") + "," + Format(Hex(Data(7)), "00")
                Case Else
                    CANStr = ""
            End Select

            list_receive.Items.Add(CANStr)
            If (Scroll = 1) Then
                list_receive.SelectedIndex = Convert.ToInt32(MsgCnt)
            End If
            MsgCnt = MsgCnt + 1
        End If
    End Sub
    Private Sub tx1_mode_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx1_mode.TextChanged
        If Val("&H" + tx1_mode.Text) > 1 Then tx1_mode.Text = "1"
    End Sub
    Private Sub tx1_id_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx1_id.TextChanged
        If Val("&H" + tx1_id.Text) > &H1FFFFFFF Then tx1_id.Text = "1fffffff"
    End Sub
    Private Sub tx1_rtr_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx1_rtr.TextChanged
        If Val("&H" + tx1_rtr.Text) > 1 Then tx1_rtr.Text = "1"
    End Sub
    Private Sub tx1_dlen_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx1_dlen.TextChanged
        If Val("&H" + tx1_dlen.Text) > 8 Then tx1_dlen.Text = "8"
    End Sub
    Private Sub bt_receive_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_receive.Click
        If (timer1.Enabled = False) Then
            timer1.Enabled = True
            bt_receive.Text = "Stop"
        Else
            timer1.Enabled = False
            bt_receive.Text = "Receive"
        End If
    End Sub
    Private Sub bt_clear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_clear.Click
        list_receive.Items.Clear()
        MsgCnt = 0
    End Sub
    Private Sub bt_scroll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_scroll.Click
        If (Scroll = 1) Then
            Scroll = 0
            bt_scroll.Text = "Scrolling"

        Else
            Scroll = 1
            bt_scroll.Text = "Stop Scroll"
        End If
    End Sub
    Private Sub bt1_send_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt1_send.Click
        Dim Mode As Byte
        Dim Rtr As Byte
        Dim Dlen As Byte
        Dim Data(8) As Byte
        Dim ID As UInteger
        Dim Ret As Short

        Mode = Convert.ToByte(tx1_mode.Text, 16)
        Rtr = Convert.ToByte(tx1_rtr.Text, 16)
        Dlen = Convert.ToByte(tx1_dlen.Text, 16)
        Data(0) = Convert.ToByte(tx1_d0.Text, 16)
        Data(1) = Convert.ToByte(tx1_d1.Text, 16)
        Data(2) = Convert.ToByte(tx1_d2.Text, 16)
        Data(3) = Convert.ToByte(tx1_d3.Text, 16)
        Data(4) = Convert.ToByte(tx1_d4.Text, 16)
        Data(5) = Convert.ToByte(tx1_d5.Text, 16)
        Data(6) = Convert.ToByte(tx1_d6.Text, 16)
        Data(7) = Convert.ToByte(tx1_d7.Text, 16)
        ID = Convert.ToUInt32(tx1_id.Text, 16)

        Ret = I87KCANnet_PAC.I87KCAN.SendCANMsg(Mode, ID, Rtr, Dlen, Data)
        If Ret <> 0 Then MessageBox.Show(Str(Ret))
    End Sub
    Private Sub tx2_mode_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx2_mode.TextChanged
        If Val("&H" + tx2_mode.Text) > 1 Then tx2_mode.Text = "1"
    End Sub
    Private Sub tx2_id_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx2_id.TextChanged
        If Val("&H" + tx2_id.Text) > &H1FFFFFFF Then tx2_id.Text = "1fffffff"
    End Sub
    Private Sub tx2_rtr_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx2_rtr.TextChanged
        If Val("&H" + tx2_rtr.Text) > 1 Then tx2_rtr.Text = "1"
    End Sub
    Private Sub tx2_dlen_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tx2_dlen.TextChanged
        If Val("&H" + tx2_dlen.Text) > 8 Then tx2_dlen.Text = "8"
    End Sub
    Private Sub bt2_send_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt2_send.Click
        Dim Mode As Byte
        Dim Rtr As Byte
        Dim Dlen As Byte
        Dim Data(8) As Byte
        Dim ID As UInteger

        Mode = Convert.ToByte(tx2_mode.Text, 16)
        Rtr = Convert.ToByte(tx2_rtr.Text, 16)
        Dlen = Convert.ToByte(tx2_dlen.Text, 16)
        Data(0) = Convert.ToByte(tx2_d0.Text, 16)
        Data(1) = Convert.ToByte(tx2_d1.Text, 16)
        Data(2) = Convert.ToByte(tx2_d2.Text, 16)
        Data(3) = Convert.ToByte(tx2_d3.Text, 16)
        Data(4) = Convert.ToByte(tx2_d4.Text, 16)
        Data(5) = Convert.ToByte(tx2_d5.Text, 16)
        Data(6) = Convert.ToByte(tx2_d6.Text, 16)
        Data(7) = Convert.ToByte(tx2_d7.Text, 16)
        ID = Convert.ToUInt32(tx2_id.Text, 16)

        I87KCANnet_PAC.I87KCAN.SendCANMsg(Mode, ID, Rtr, Dlen, Data)
    End Sub
End Class
