
#ifndef _I87KCAN_H
#define _I87KCAN_H

#ifdef __cplusplus
extern "C" {
#endif

#ifdef I87KCAN_EXPORTS
#define I87KCAN_API __declspec(dllexport)
#else
#define I87KCAN_API __declspec(dllimport)
#endif

#define CAN87K_OK                    0
#define CAN87K_TIMEOUT              21
#define CAN87K_FIFO_EMPTY           22
#define CAN87K_FIFO_FULL            23
#define CAN87K_INIT_ERROR           24
#define CAN87K_PARATERS_ERROR       25
#define CAN87K_CAN_REG_ERROR        26

I87KCAN_API int I87KCANConfig(BYTE Slot, BYTE Ack, BYTE BufferSize);

I87KCAN_API int GetI87KCANConfig(BYTE Slot, BYTE *Ack, BYTE *BufferSize);

I87KCAN_API int SetCANBaud(BYTE Slot, DWORD Baud, BYTE BT0, BYTE BT1);

I87KCAN_API int GetCANBaud(BYTE Slot, DWORD *Baud, BYTE *BT0, BYTE *BT1);

I87KCAN_API int SetCANMask(BYTE Slot, DWORD AccCode, DWORD AccMask);

I87KCAN_API int GetCANMask(BYTE Slot, DWORD *AccCode, DWORD *AccMask);

I87KCAN_API int ClearStatus(BYTE Slot);

I87KCAN_API int GetStatus(BYTE Slot, BYTE *CANReg, BYTE *OverflowFlag);

I87KCAN_API int ResetI87KCAN(BYTE Slot);

I87KCAN_API int I87KCANInit(BYTE Slot, HANDLE hPort, DWORD CANBaud, BYTE BT0, BYTE BT1, DWORD CAN_AccCode, DWORD CAN_Mask, BYTE Ack, BYTE BufferSize);

I87KCAN_API int GetCANMsg(BYTE Slot, BYTE *Mode, DWORD *MsgID, BYTE *RTR, BYTE *DataLen, BYTE *Data);

I87KCAN_API int SendCANMsg(BYTE Slot, BYTE Mode,DWORD MsgID, BYTE RTR, BYTE DataLen, BYTE* Data);

I87KCAN_API int SendCmdStr(BYTE Slot, BYTE HintChar, char *SendString);

I87KCAN_API int SendCmdBufn(BYTE Slot, BYTE HintChar, char *TempBuf, WORD CharNum);

I87KCAN_API int SendRecCmdStr(BYTE Slot, char *CmdStr, char *RecBuf);

#ifdef __cplusplus
}
#endif

#endif	// #ifndef _I87KCAN_H