// WinPac_demo1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "WinPac_demo1.h"
#include "WinPac_demo1Dlg.h"
#include <WinconSDK.h>
#include <Uartce.h>
#include "I87KCAN.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWinPac_demo1Dlg dialog

CWinPac_demo1Dlg::CWinPac_demo1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWinPac_demo1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWinPac_demo1Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWinPac_demo1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinPac_demo1Dlg)
	DDX_Control(pDX, IDC_EDIT_SLOT, m_slot);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_baud);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWinPac_demo1Dlg, CDialog)
	//{{AFX_MSG_MAP(CWinPac_demo1Dlg)
	ON_BN_CLICKED(IDC_BUTTON_CONFIG, OnButtonConfig)
	ON_BN_CLICKED(IDC_BUTTON_SEND, OnButtonSend)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	ON_BN_CLICKED(IDC_BUTTON_EXIT, OnButtonExit)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinPac_demo1Dlg message handlers
#define comport 0

BOOL CWinPac_demo1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWinPac_demo1Dlg::OnButtonConfig() 
{
	int Ret;
	unsigned long baud;
	wchar_t wTempValue[10];
	wchar_t wTempStr[100];
	char TempValue[10];
	// TODO: Add your control notification handler code here
	Ret=Open_Com(comport,115200UL,8,0,0);	//	For WinPac communicate with slot module
	if (Ret){
		Ret = Close_Com(comport);
		if(Ret){
			MessageBox(_T("Close com Err"),NULL,NULL);
			return;
		}
		Ret=Open_Com(comport,115200UL,8,0,0);
		if (Ret){
			wsprintf(wTempStr,_T("Open Com Error, Error Code=%d"),Ret);
			MessageBox(wTempStr,_T("Error"),MB_OK);
			return;
		}
	}

	m_slot.GetWindowText(wTempValue,10);
	wcstombs(TempValue,wTempValue,10);

	ChangeSlotTo87K((BYTE)(atoi(TempValue)));	// Change slot to I-87120

	switch(m_baud.GetCurSel()){	//	Set CAN port baud rate
	case 0:
		baud = 10000L;
		break;
	case 1:
		baud = 20000L;
		break;
	case 2:
		baud = 50000L;
		break;
	case 3:
		baud = 125000L;
		break;
	case 4:
		baud = 250000L;
		break;
	case 5:
		baud = 500000L;
		break;
	case 6:
		baud = 800000L;
		break;
	case 7:
		baud = 1000000L;
		break;
	}

	Ret=I87KCANInit(baud,0,0,0x00000000L,0xffffffffL,0,0);	// Configure CAN port
	if (Ret){
		wsprintf(wTempStr,_T("I87KCAN Initialize Error, Error Code=%d"),Ret);
		MessageBox(wTempStr,_T("Error"),MB_OK);
		Ret = Close_Com(comport);
		if(Ret) MessageBox(_T("Close com Err"),NULL,NULL);
		return;
	}
}

//Send: Enable timer function of F_demo1 to send a CAN message per 1000 ms;
//Stop: Disable timer function
//Exit: Exit program

void CWinPac_demo1Dlg::OnButtonSend() 
{
	char TempBuf[100];
	// TODO: Add your control notification handler code here
	sprintf(TempBuf,"_A1000\n");
	Send_Cmd(comport,TempBuf,0);
}

void CWinPac_demo1Dlg::OnButtonStop() 
{
	char TempBuf[100];
	// TODO: Add your control notification handler code here
	sprintf(TempBuf,"_B\n");
	Send_Cmd(comport,TempBuf,0);
}

void CWinPac_demo1Dlg::OnButtonExit() 
{
	// TODO: Add your control notification handler code here
	OnDestroy();
}

void CWinPac_demo1Dlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	Close_Com(comport);
}
