// sendmsgDlg.cpp : @
//

#include "stdafx.h"
#include "sendmsg.h"
#include "sendmsgDlg.h"

#include "..\..\87CANlib\ver_120\I87KCAN.h"
#include <XPacSDK_CE.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CsendmsgDlg ܤ

CsendmsgDlg::CsendmsgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CsendmsgDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CsendmsgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_DATALEN_EDIT, m_DataLen);
	DDX_Control(pDX, IDC_11BIT_RADIO, m_11bit);
	DDX_Control(pDX, IDC_SLOT_COMBO, m_Slot);
	DDX_Control(pDX, IDC_SEND_BUTTON, m_Send);
	DDX_Control(pDX, IDC_RTR_CHECK, m_RTR);
	DDX_Control(pDX, IDC_RESET_BUTTON, m_Reset);
	DDX_Control(pDX, IDC_INIT_BUTTON, m_Init);
	DDX_Control(pDX, IDC_ID_EDIT, m_ID);
	DDX_Control(pDX, IDC_DATA_EDIT, m_Data);
	DDX_Control(pDX, IDC_BAUD_COMBO, m_Baud);
}

BEGIN_MESSAGE_MAP(CsendmsgDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_CBN_SELENDOK(IDC_SLOT_COMBO, OnSelendokSlotCombo)
	ON_BN_CLICKED(IDC_INIT_BUTTON, OnInitButton)
	ON_BN_CLICKED(IDC_RESET_BUTTON, OnResetButton)
	ON_BN_CLICKED(IDC_SEND_BUTTON, OnSendButton)
	ON_BN_CLICKED(IDC_29BIT_RADIO, On29bitRadio)
	ON_BN_CLICKED(IDC_11BIT_RADIO, On11bitRadio)
END_MESSAGE_MAP()


// CsendmsgDlg TBz`


WORD PortEnable;
BYTE OldSlotSelect = 0;
HANDLE HPORT = NULL;

void CsendmsgDlg::FormInit(void){
	WORD TempRet;
	//Initiate all objects and parameters used in the dialog
	m_Reset.EnableWindow(FALSE);
	m_11bit.EnableWindow(FALSE);
	m_29bit.EnableWindow(FALSE);
	m_ID.EnableWindow(FALSE);
	m_RTR.EnableWindow(FALSE);
	m_DataLen.EnableWindow(FALSE);
	m_Data.EnableWindow(FALSE);
	m_Send.EnableWindow(FALSE);
	TempRet=uart_Close(HPORT);
	if (TempRet == FALSE) return;
	PortEnable=0;
}

BOOL CsendmsgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ]wܤϥܡCε{DOܤɡA
	// ج[|۰ʱqƦ@~
	SetIcon(m_hIcon, TRUE);			// ]wjϥ
	SetIcon(m_hIcon, FALSE);		// ]wpϥ

	// TODO: b[JB~l]w
	
	// Initial Slot ComBo-Box
	m_Slot.AddString(_T("Slot 0"));
	m_Slot.AddString(_T("Slot 1"));
	m_Slot.AddString(_T("Slot 2"));
	m_Slot.AddString(_T("Slot 3"));
	m_Slot.AddString(_T("Slot 4"));
	m_Slot.AddString(_T("Slot 5"));
	m_Slot.AddString(_T("Slot 6"));
	m_Slot.AddString(_T("Slot 7"));

	// Initial Baudrate ComBo-Box
	m_Baud.AddString(_T("      5K bps"));
	m_Baud.AddString(_T("    10K bps"));
	m_Baud.AddString(_T("    20K bps"));
	m_Baud.AddString(_T("    25K bps"));
	m_Baud.AddString(_T("    50K bps"));
	m_Baud.AddString(_T("  100K bps"));
	m_Baud.AddString(_T("  125K bps"));
	m_Baud.AddString(_T("  200K bps"));
	m_Baud.AddString(_T("  250K bps"));
	m_Baud.AddString(_T("  500K bps"));
	m_Baud.AddString(_T("  800K bps"));
	m_Baud.AddString(_T("1000K bps"));
	m_Baud.AddString(_T("User-defined"));

	//initial button
	FormInit();

	//parameter initialize
	m_Slot.SetCurSel(0);
	OldSlotSelect=0;
	m_11bit.SetCheck(BST_CHECKED);
	m_Baud.SetCurSel(11);
	m_DataLen.LimitText(1);
	m_DataLen.SetWindowText(_T("8"));
	m_Data.LimitText(23);
	m_Data.SetWindowText(_T("FF FF FF FF FF FF FF FF"));
	m_ID.LimitText(3);
	m_ID.SetWindowText(_T("3FF"));
	m_11bit.SetCheck(TRUE);

	return TRUE;  // Ǧ^ TRUEADzﱱ]wJI
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CsendmsgDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_SENDMSG_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_SENDMSG_DIALOG));
	}
}
#endif

void CsendmsgDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	//recover the timer setting and COM 0 setting
	if (PortEnable) uart_Close(HPORT);
}

void CsendmsgDlg::OnSelendokSlotCombo() 
{
	//Check if the slot combo box is changed or not, and do something for different situation
	if (m_Slot.GetCurSel()!=OldSlotSelect){
		FormInit();
		OldSlotSelect=m_Slot.GetCurSel();
		return;
	}
}

void CsendmsgDlg::OnInitButton() 
{
	wchar_t wTempStr[100];
	WORD Ret;
	CString TempStr;
	DWORD BaudMap[]={5000UL,10000UL,20000UL,25000UL,50000UL,100000UL,125000UL,
				     20000UL,250000UL,500000UL,800000UL,1000000UL};
	
	// Open Com0 For All I-87K Module
	HPORT = uart_Open("");	// COM0,115200,N,8,1
	if(HPORT == INVALID_HANDLE_VALUE){
		FormInit();
		wsprintf(wTempStr,_T("Open Com0 Error"));
		MessageBox(wTempStr,_T("Error"),MB_OK);
		return;
	}

	PortEnable=1;

	//Select the slot where the I-87120 is plugged.
	//ChangeSlotTo87K(m_Slot.GetCurSel());
	OldSlotSelect = m_Slot.GetCurSel();

	//configue the I-87KCAN setting and initiate the I-87KCAN
	Ret=I87KCANInit(OldSlotSelect,HPORT,BaudMap[m_Baud.GetCurSel()],0,0,0x00000000UL,0xffffffffUL,0,0);
	if (Ret){
		wsprintf(wTempStr,_T("Initiate I-87KCAN Error, Error Code=%d"),Ret);
		MessageBox(wTempStr,_T("Error"),MB_OK);
		return;
	}

	//start the objects and parameters used in the dialog
	m_Reset.EnableWindow(TRUE);
	m_11bit.EnableWindow(TRUE);
	m_29bit.EnableWindow(TRUE);
	m_ID.EnableWindow(TRUE);
	m_RTR.EnableWindow(TRUE);
	m_DataLen.EnableWindow(TRUE);
	m_Data.EnableWindow(TRUE);
	m_Send.EnableWindow(TRUE);
}

void CsendmsgDlg::OnResetButton() 
{
	//Send command to reset the I-87KCAN module
	WORD Ret;
	wchar_t wTempStr[200];
	Ret=ResetI87KCAN(OldSlotSelect);
	if (Ret){
		FormInit();
		wsprintf(wTempStr,_T("Get Status Error, Error Code=%d"),Ret);
		MessageBox(wTempStr,_T("Error"),MB_OK);
		return;
	}
}

void CsendmsgDlg::OnSendButton() 
{
	wchar_t wTempStr[100],*wendptr;
	char TempStr[100],*ptr1,*ptr2,*endptr;
	BYTE Mode,RTR,DataLen,Data[8];
	WORD i,Ret;
	DWORD ID;

	//configue the transmit CAN message
	m_ID.GetWindowText(wTempStr,16);
	ID=_tcstoul(wTempStr,&wendptr,16);
	if (m_11bit.GetCheck()){
		Mode=0;
	}
	else{
		Mode=1;
	}
	if (m_RTR.GetCheck()){
		RTR=1;
	}
	else{
		RTR=0;
	}
	m_DataLen.GetWindowText(wTempStr,2);
	DataLen=(BYTE)(_tcstoul(wTempStr,&wendptr,10)&0xff);
	if (DataLen>8) DataLen=8;
	m_Data.GetWindowText(wTempStr,46);
	wcstombs(TempStr,wTempStr,46);
	sprintf(TempStr,"%s ",TempStr);
	i=0;
	ptr1=TempStr;
	ptr2=strchr(TempStr,' ');
	while(ptr2){
		*ptr2=0;
		if (i>7) break;
		Data[i]=(BYTE)(strtoul(ptr1, &endptr,16)&0xff);
		i++;
		ptr1=ptr2+1;
		ptr2=strchr(ptr1,' ');
	}
	while(i<DataLen){
		Data[i]=0;
		i++;
	}

	//Send the CAN message out
	Ret=SendCANMsg(OldSlotSelect,Mode,ID,RTR,DataLen,Data);
	if (Ret){
		wsprintf(wTempStr,_T("Send CAN Message Error, Error Code=%d"),Ret);
		MessageBox(wTempStr,_T("Error"),MB_OK);
	}	
}

void CsendmsgDlg::On29bitRadio() 
{
	// TODO: Add your control notification handler code here
	m_ID.LimitText(8);
	m_ID.SetWindowText(_T("1FFFFFFF"));	
}

void CsendmsgDlg::On11bitRadio() 
{
	// TODO: Add your control notification handler code here
	m_ID.LimitText(3);
	m_ID.SetWindowText(_T("3FF"));
}


